
package org.nst.pasientlink.authenticator;

/**
 * <p>Title: TestRequest  </p>
 * <p>Description: unit tests for Request class</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Norwegian Centre for Telemedicine</p>
 * @author Thomas Strandens
 * @version 1.0
 */

import junit.framework.*;
import org.nst.pasientlink.authenticator.*;

public class TestRequest extends TestFixture {

  private Request request;
  private int TEST_REQUEST_TIMEOUT = 1;

  public TestRequest(String s) {
    super(s);
  }

  /**
   * intialize test request inlcuding generated single use password
   */

   public void setUp() {
      super.setUp();
      this.request = new Request(TEST_REQUEST_TIMEOUT, this.getTestUserID(), this.getUtility().generateSingleUsePassword());
   }

   public void tearDown() {
      super.tearDown();
   }

   /**
    * first a few simple get method tests...
    */

   public void testGetSingleUsePassword() {
      assertNotNull("Got wrong UserID", request.getSingleUsePassword());
   }

   public void testGetUserID() {
      assertEquals("Got wrong UserID", request.getUserID(), this.getTestUserID());
   }

   /**
    * test that the request times out correctly. setup() arranges for the timeout
    */

   public void testIsTimedOut() {
      assertTrue("Request should not be timed out at this point", !request.isTimedOut());
      // sleep past the test timeout...
      try {
         Thread.currentThread().sleep((TEST_REQUEST_TIMEOUT*60*1000)+100);
      }
         catch(InterruptedException e) {
      }
      assertTrue("Request should have timed out at this point", request.isTimedOut());
   }
}
